%define __spec_install_post /usr/lib/rpm/brp-compress %{nil}
%define debug_package %{nil}

%define default_toolprefix /usr/tools/roku
%{?toolprefix:%define default_toolprefix %{toolprefix}}

%define default_cross_os linux
%{?cross_os:%define default_cross_os %{cross_os}}

%define do_codename 0
%{?codename:%define do_codename 1}

%define default_codename ""
%{?codename:%define default_codename %{codename}}

%define redhat_6_2_compat 0
%{?do_redhat_6_2_compat:%define redhat_6_2_compat 1}

%if %{redhat_6_2_compat}
%define GCC i386-glibc21-linux-gcc
%else
%define GCC gcc
%endif

%define do_i386_only 0
%{?do_i386:%define do_i386_only 1}
%define do_mips_only 0
%{?do_mips:%define do_mips_only 1}
%define do_mipsel_only 1
%{?do_mipsel:%define do_mipsel_only 1}

%define i386_target i386
%define mips_target mips
%define mipsel_target mipsel

%define build_i386 1
%define build_mips 1
%define build_mipsel 1

%if %{do_i386_only}
%define mips_target	""
%define mipsel_target	""
%define build_mips 0
%define build_mipsel 0
%endif

%if %{do_mips_only}
%define i386_target	""
%define mipsel_target	""
%define build_i386 0
%define build_mipsel 0
%endif

%if %{do_mipsel_only}
%define i386_target	""
%define mips_target	""
%define build_i386 0
%define build_mips 0
%endif

%define all_tagerts %{i386_target} %{mips_target} %{mipsel_target}

%define glibc_version 2.2.4

Summary: The GNU cross compile toolchain for Linux
Name: rokutools
Version: 20020423
Release: 1
Copyright: GPL
Group: Development/Tools
Source0: tools-%{version}.tar.bz2
Source1: tools-glibc-%{glibc_version}.tar.bz2
Patch: lf.patch
%if %{redhat_6_2_compat}
BuildPrereq: compat-gcc = 6.2
BuildPrereq: compat-glibc = 6.2
%endif

Prefix: %{default_toolprefix}
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root
Epoch: 1
ExclusiveArch: %{ix86}

%define __find_provides %{_builddir}/%{name}/find_provides.sh
%define __find_requires %{_builddir}/%{name}/find_requires.sh

%description
The common files in the GNU cross compile toolchain for Linux.

%package i386
Summary: The i386 part of the GNU cross compile toolchain
Group: Development/Tools
Requires: %{name} = %{version}-%{release}

%description i386
The i386 part of the GNU cross compile toolchain.

%package mips
Summary: The mips part of the GNU cross compile toolchain
Group: Development/Tools
Requires: %{name} = %{version}-%{release}

%description mips
The mips part of the GNU cross compile toolchain.

%package mipsel
Summary: The mipsel part of the GNU cross compile toolchain
Group: Development/Tools
Requires: %{name} = %{version}-%{release}

%description mipsel
The mipsel part of the GNU cross compile toolchain.

%prep
%setup -q -n %{name} -c -a 1
%patch

%if %{do_codename}
for v in gcc/version.c gcc/f/version.c; do
  perl -pi -e 's/\";$/ %{default_codename}";/' tools-%{version}/$v
done
%endif

copy_glibc()
{
  cross_arch=$1
  cross_target=$cross_arch-%{default_cross_os}
  tooldir=%{prefix}/$cross_target
  mkdir -p $tooldir
  rm -rf glibc-$cross_arch
  mkdir glibc-$cross_arch
  cd glibc-$cross_arch
  for d in usr lib; do
    cp -af ../glibc/$cross_arch/$d .;
  done
  cp -af usr/include usr/lib lib $tooldir
  rm -rf lib
  cd usr/lib
  for l in `find -type l`; do
    link=`file $l | grep "broken symbolic" 2> /dev/null` || true
    if [ -n "$link" ]; then
      lib=`echo $link | awk '{print $6;}'`
      rm -f $tooldir/lib/$l
      ln -s `basename $lib` $tooldir/lib/$l
    fi
  done
  dl=`readelf -d $tooldir/lib/libc.so.* | grep NEEDED | \
	sed -e "s/.*\[\(.*\)\].*/\1/"`
  sed -e "s,/lib/libc.so,$tooldir/lib/libc.so," \
    -e "s,/usr/lib/libc,$tooldir/lib/$dl /usr/lib/libc," \
    -e "s,/usr/lib/libc,$tooldir/lib/libc," \
	libc.so > $tooldir/lib/libc.so 
  sed -e "s,/lib/libbpthread.so,$tooldir/lib/libbpthread.so," \
      -e "s,/lib/librt.so,$tooldir/lib/librt.so," \
	librt.so > $tooldir/lib/librt.so 
  (
    cd $tooldir
    mkdir -p %{_builddir}/%{name}/libc/$tooldir
    cp -af include lib %{_builddir}/%{name}/libc/$tooldir
  )
  cd ../../..
  rm -rf glibc-$cross_arch
}

rm -rf %{_builddir}/%{name}/libc
if [ -e %{prefix} ]; then
  if [ -e %{prefix}.saved ]; then
    echo %{prefix}.saved exists. Cannot continue.
    exit 1
  fi
  rm -rf %{prefix}.saved
  mv %{prefix} %{prefix}.saved
fi
for t in %{all_tagerts}; do
  test -n "$t" || continue
  copy_glibc $t
done

cat > find_provides.sh <<EOF
#!/bin/sh
while read file; do
  case \$file in
  %{buildroot}%{prefix}/*-%{default_cross_os}/*)
    ;;
  *)
    echo \$file
    ;;
  esac
done |
/usr/lib/rpm/find-provides |
grep -v libbfd |
grep -v libopcodes
exit 0
EOF
chmod +x find_provides.sh

cat > find_requires.sh <<EOF
#!/bin/sh
while read file; do
  case \$file in
  %{buildroot}%{prefix}/*-%{default_cross_os}/*)
    ;;
  *)
    echo \$file
    ;;
  esac
done |
/usr/lib/rpm/find-requires |
grep -v libbfd |
grep -v libopcodes
exit 0
EOF
chmod +x find_requires.sh

%build
enable_targets=i386-linux
for t in %{all_tagerts}; do
  test -n "$t" || continue
  case $t in
  i386)
    ;;
  *)
    enable_targets="$enable_targets,$t-linux"
    ;;
  esac
done

if [ -x /usr/bin/getconf ] ; then
  numprocs=$(/usr/bin/getconf _NPROCESSORS_ONLN)
  if [ $numprocs -eq 0 ]; then
    numprocs=1 
  fi
else
  numprocs=1
fi
numprocs=`expr $numprocs + $numprocs`

build_tool()
{
  cross_arch=$1
  cross_target=$cross_arch-%{default_cross_os}
  mkdir build-$cross_target
  cd build-$cross_target
  CC=%{GCC} \
  ../tools-%{version}/configure \
	--target=$cross_target \
	--enable-targets=$enable_targets \
	--prefix=%{prefix} \
	--with-local-prefix=%{prefix} \
	--enable-threads=posix \
	--enable-haifa \
	--enable-shared \
	--disable-checking
  make -C bfd headers

  make -j $numprocs
  cd ..
}

for t in %{all_tagerts}; do
  test -n "$t" || continue
  build_tool $t
done

# Build gdb info pages.
for t in %{all_tagerts}; do
  test -n "$t" || continue
  make info -C build-$t-%{default_cross_os}/gdb
  break
done

%install
rm -rf ${RPM_BUILD_ROOT}
for t in %{all_tagerts}; do
  test -n "$t" || continue
  cd build-$t-%{default_cross_os}
  make install prefix=${RPM_BUILD_ROOT}%{prefix}
  cd ..
  install -m 644 tools-%{version}/include/libiberty.h \
	${RPM_BUILD_ROOT}%{prefix}/$t-%{default_cross_os}/include
done

# Install info pages.
for t in %{all_tagerts}; do
  test -n "$t" || continue
  for d in bfd binutils gas gdb ld; do
    make -C build-$t-%{default_cross_os}/$d \
	install-info prefix=${RPM_BUILD_ROOT}%{prefix}
  done
  break
done

cd libc
cp -af . ${RPM_BUILD_ROOT}
cd ..

rm -f lib.list
for f in `ls ${RPM_BUILD_ROOT}%{prefix}/lib`; do
  case $f in
  gcc-lib)
    ;;
  *)
    echo %{prefix}/lib/$f >> lib.list
    ;;
  esac
done

rm -rf %{prefix}
if [ -e %{prefix}.saved ]; then
  mv %{prefix}.saved %{prefix}
fi

%clean
rm -rf ${RPM_BUILD_ROOT} lib.list

%files -f lib.list
%defattr(-,root,root)
%dir %{prefix}
%dir %{prefix}/bin
%dir %{prefix}/lib
%dir %{prefix}/man
%dir %{prefix}/man/man1
%{prefix}/bin/*
%{prefix}/man/man1/*
%{prefix}/share/locale/*/LC_MESSAGES/*
%{prefix}/include
%{prefix}/info

%if %{build_i386}
%files i386
%defattr(-,root,root)
%{prefix}/bin/i386-%{default_cross_os}-*
%{prefix}/lib/gcc-lib/i386-%{default_cross_os}
%{prefix}/man/man1/i386-%{default_cross_os}-*
%{prefix}/i386-%{default_cross_os}
%endif

%if %{build_mips}
%files mips
%defattr(-,root,root)
%{prefix}/bin/mips-%{default_cross_os}-*
%{prefix}/lib/gcc-lib/mips-%{default_cross_os}
%{prefix}/man/man1/mips-%{default_cross_os}-*
%{prefix}/mips-%{default_cross_os}
%endif

%if %{build_mipsel}
%files mipsel
%defattr(-,root,root)
%{prefix}/bin/mipsel-%{default_cross_os}-*
%{prefix}/lib/gcc-lib/mipsel-%{default_cross_os}
%{prefix}/man/man1/mipsel-%{default_cross_os}-*
%{prefix}/mipsel-%{default_cross_os}
%endif

%changelog
* Fri May 28 2004 Jon Lech Johansen <jon@nanocrew.net>
- Use glibc version 2.2.4-33.

* Tue Apr 23 2002 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20020423 with gdb 5.2-0.3
  (5.1.91-2002-04-23-cvs) and binutils 2.12.90.0.7.

* Sun Apr 21 2002 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20020421 with gcc 2.96-110,
  glibc 2.2.5-34, gdb 5.2-0.3 (5.1.91-2002-04-21-cvs) and binutils
  2.12.90.0.5.

* Mon Apr  8 2002 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20020408 with gcc 2.96-109,
  glibc 2.2.5-30, gdb 5.2-0.2 (5.1.90-2002-04-08-cvs) and binutils
  2.12.90.0.4.

* Tue Mar 26 2002 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20020323 with gcc 2.96-107,
  glibc 2.2.5-27, gdb 5.2-0.1 (5.1.90-2002-03-22-cvs) and binutils
  2.12.90.0.3.

* Thu Feb  7 2002 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20020207 with gdb 5.1.0.1 and
  binutils 2.11.93.0.2.

* Mon Nov 26 2001 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20011125 with gdb 5.1 and binutils
  2.11.92.0.12.

* Sun Oct 21 2001 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20011020 with binutils 2.11.92.0.10.

* Sat Oct 20 2001 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20011020 with binutils 2.11.92.0.8.

* Wed Oct 17 2001 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20011015 with gcc 2.96-99, gdb 5.0.91
  2001-10-15-cvs, glibc 2.2.4-19 and binutils 2.11.92.0.7.

* Thu Aug 30 2001 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20010830 with binutils 2.11.90.0.31.

* Tue Aug 28 2001 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20010827 with gdb 5.0.90 2000-08-21,
  binutils 2.11.90.0.29, glibc 2.2.4 and gcc 2.96-97.

* Fri Aug 10 2001 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20010810 with gcc 2.96-96, gdb 5.0.90
  2000-08-10 and binutils 2.11.90.0.27.

* Thu Jul 26 2001 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20010726 with gcc 2.96-95 and
  binutils 2.11.90.0.25.

* Wed Jul 25 2001 H.J. Lu <hjl@gnu.org>
- Add selective build.

* Sun Jul 15 2001 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20010713 with gcc 2.96-94 and
  binutils 2.11.90.0.24.
- Add gdb 2001-07-13-cvs.

* Sun Jul  8 2001 H.J. Lu <hjl@gnu.org>
- Update the toolchain version to 20010707 with gcc 2.96-93 and
  binutils 2.11.90.0.23.
- Fix the gcc stabs assembly output.

* Sun Jun 24 2001 H.J. Lu <hjl@gnu.org>
- Initial version.
